
# coding: utf-8

# In[39]:

#modules 
get_ipython().magic('matplotlib inline')
import scipy
import numpy as np
import datetime 
import statistics
import glob
import xarray as xr
import time
import math
import warnings
import os
import xlrd

import pandas as pd 
import matplotlib.pyplot as plt
from matplotlib.ticker import (MultipleLocator, FormatStrFormatter,
                               AutoMinorLocator)
from scipy import stats
from sklearn.metrics import r2_score, mean_squared_error


# ### Files ACE & MHD 

# In[2]:



file1 = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\data_MHD_daily.csv'
file2 = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\data_filtered_IRA_ACE_FTS_clean.csv'

df1 = pd.read_csv(file1, sep=';', header=0)
df2 = pd.read_csv(file2, sep=';', header=0)






# In[3]:


datetime = pd.to_datetime(df1[['year','month','day']]) # création d'un vecteur "datetime" regroupant yyyy-mm-dd
df1['datetime'] = datetime #ajout de la colonne "datetime" dans le dataframe 
df1 = df1.set_index('datetime',drop=True) #je place la colonne créee en index 

datetime = pd.to_datetime(df2[['year','month','day']]) # création d'un vecteur "datetime" regroupant yyyy-mm-dd
df2['datetime'] = datetime #ajout de la colonne "datetime" dans le dataframe 
df2 = df2.set_index('datetime',drop=True) #je place la colonne créee en index 



# In[4]:

###calcul daily_mean IRA 

# Daily
df_daily_IRA = df2.resample('D').mean()
df_daily_IRA = df_daily_IRA.dropna()



# In[5]:

### création new dataframe pour avoir seulement yearfraction et concentration CHF3 de ACE et de Mace Head 


df_MHD = df1.loc[:, ['yearfraction', 'daily_mean']]
df_ACE_IRA = df_daily_IRA.loc[:, ['yearfraction', 'CHF3_ppt']]


# In[6]:

df_merged = pd.merge(df_MHD, df_ACE_IRA, left_index=True, right_index=True) #on merge sur l'index de chaque dataframe pour ne pas perdre d'infos





# ### Files Jung CHF3 & Jung PAN 

# In[12]:

file3 = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\hfc23_1138_1160_2007_2020_atm_R1_13000_fixed_snr.out_filtered.csv'
df3 = pd.read_csv(file3, sep=',', header=0)


path_xls = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\PAN_20000107.094912_20220325.075917_pan_tst.w2_a055.atm16_2022-5-2.xls'
name_sheet = 'RESULTS'


# Charger le fichier XLS dans un objet DataFrame de pandas
df4 = pd.read_excel(path_xls, sheet_name=name_sheet)



# In[13]:

# Split the date
date =  df3['Unnamed: 0'].values

years = []
months = []
days = []
hours = []
minutes = []
seconds = []

for i in range(0,len(date)) :
    data = str("{0:.6f}".format(date[i]))
    year = int(data[0:4])
    years.append(year)
    month = int(data[4:6])
    months.append(month)
    day = int(data[6:8])
    days.append(day)
    hour = int(data[9:11])
    hours.append(hour)
    minute = int(data[11:13])
    minutes.append(minute)
    second = int(data[13:15])
    seconds.append(second)


# In[14]:

## transform date en mode datetime avec methode datetime 

# Add datetime to df

df3['year'] = years
df3['month'] = months
df3['day'] = days
df3['hour'] = hours
df3['minute'] = minutes
df3['second'] = seconds

datetime = pd.to_datetime(df3[['year','month','day']])
df3['datetime'] = datetime
df3 = df3.set_index('datetime',drop=True)

df3


# In[15]:

# Daily
df3_daily = df3.resample('D').mean()
df3_daily = df3_daily.dropna()


# In[16]:

df4 = df4.set_index('DATE',drop=True)


# In[17]:

df4


# In[18]:

# Daily
df4_daily = df4.resample('D').mean()
df4_daily = df4_daily.dropna()


# In[19]:

df4_daily


# In[20]:

df3_daily


# In[21]:

### le fichier du Jung de mon run (df3)

# Sélectionner les colonnes "colonne1" et "colonne2" en utilisant la méthode loc
df3_new = df3_daily.loc[:, ["YearFraction", "retrieved_total_column__CHF3"]]


df4_new = df4_daily.loc[:, ["YearFraction", "CHF3"]]

#df3_new


# In[22]:

df_merged_2 = pd.merge(df3_new, df4_new, left_index=True, right_index=True)



# In[23]:

df_merged_2


# # Statistiques MHD & ACE_IRA 

# In[57]:

#df_daily_IRA
df_MHD


# In[58]:

# df_merge 
df_merged


# ## Random error 

# In[59]:

mean_MHD = df_merged['daily_mean'].mean()
mean_ACE_IRA = df_merged['CHF3_ppt'].mean()

std_MHD = df_merged['daily_mean'].std(ddof=1)
std_ACE_IRA = df_merged['CHF3_ppt'].std(ddof=1)

median_MHD = df_merged['daily_mean'].median()
median_ACE_IRA = df_merged['CHF3_ppt'].median()

# Calculate the random error as the standard deviation divided by the square root of the number of measurements:
random_error_MHD = std_MHD/ np.sqrt(len(df_merged['daily_mean']))
random_error_ACE_IRA = std_ACE_IRA/ np.sqrt(len(df_merged['CHF3_ppt']))


# In[60]:

print('La valeur de la moyenne des données MHD est :', mean_MHD)
print('La valeur de la moyenne des données ACE (IRA) est :',mean_ACE_IRA)

print('La valeur de STD des données MHD (dofs = 1) est:', std_MHD)
print('La valeur de STD des données ACE (IRA + dofs = 1) est : ', std_ACE_IRA)

print('La valeur de la médiane des données MHD est :', median_MHD)
print('La valeu de la médiane des données ACE (IRA) est : ', median_ACE_IRA)


print('La valeur de la random error  des données MHD est :', random_error_MHD)
print('La valeur de la random error  des données ACE (IRA) est :',random_error_ACE_IRA)


# # Autre stat d'après le code Issep (Coraline) 

# In[61]:

X = df_merged['CHF3_ppt'] #calculated value 
Y = df_merged['daily_mean'] #predicted value 


# In[65]:

##visualisation du jeu de donnée 
axes = plt.axes()
axes.grid()
plt.axis([10, 40, 10, 40])
plt.scatter(X,Y, marker='+', s=15)
plt.title('Observed VS predicted Values')
plt.xlabel('Observed Values (ACE)')
plt.ylabel('Predicted Values (MHD)')
plt.show()


# In[66]:

## entrainement modèle regression linéaire 
slope, intercept, r_value, p_value, std_err = stats.linregress(X, Y)


# In[67]:

slope, intercept, r_value, p_value, std_err
#afficher différents paramètres stat 


# In[68]:

## écriture de la fonction de prédiction 
def predict(x):
    return slope * x + intercept


# In[69]:

output_plot = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\out_plot_stat\\'

a = round(slope, 4)
b = round(intercept, 4)


## affichage de la fonction de prédiction 
axes = plt.axes()
axes.grid()
plt.axis([10, 40, 10, 40]) #pour mettre la même échelle de valeur selon x et y 
plt.scatter(X,Y, marker='+', s=15, label='data')
plt.title('Observed VS predicted Values')
plt.xlabel('Observed Values (ACE)')
plt.ylabel('Predicted Values (MHD)')
regression_coef = a
regression_intercept = b
fitLine = predict(X)
plt.plot(X, fitLine, c='r', label=f'equation: {regression_coef}x + {regression_intercept}')    
plt.plot(slope)
plt.legend(loc='best')
plt.savefig(output_plot + 'Observed_vs_predicted_ACE_IRA_MHD.png', dpi=300)
plt.show()

# affichage de a et de b (fonction round pour arrondir)
print("La valeur de a est:", a)
print("La valeur de b est:", b)







# In[70]:

#Compute statistics
    #CORRELATION
column_1 = Y #predicted value
column_2 = X #calculate value
corr = column_1.corr(column_2)

#corr


# In[71]:

#ROOT MEAN SQUARE ERREOR
RMSE =((Y - X) ** 2).mean() ** .5
RMSE


# In[77]:

#MEAN BIASES
Mean_biais =((Y- X)).mean()
Mean_biais


# In[78]:

stat_resume='R\u00B2='+str(round(corr, 2))+", Mean biais="+str(round(Mean_biais, 1))+", RMSE="+str(round(RMSE, 1))
print(stat_resume)
#\u00B2 -> à mettre après le 'R' pour avoir l'exposant au carré


# # Statistiques PAN (CHF3) & CHF3 (CHF3)

# In[79]:

df_merged_2


# In[81]:

mean_CHF3 = df_merged_2['retrieved_total_column__CHF3'].mean()
mean_PAN = df_merged_2['CHF3'].mean()


std_CHF3 = df_merged_2['retrieved_total_column__CHF3'].std(ddof=1)
std_PAN = df_merged_2['CHF3'].std(ddof=1)

median_CHF3 = df_merged_2['retrieved_total_column__CHF3'].median()
median_PAN = df_merged_2['CHF3'].median()

# Calculate the random error as the standard deviation divided by the square root of the number of measurements:
random_error_CHF3 = std_CHF3/ np.sqrt(len(df_merged_2['retrieved_total_column__CHF3']))
random_error_PAN = std_PAN/ np.sqrt(len(df_merged_2['CHF3']))


# In[82]:

print('La valeur de la moyenne des données CHF3 est : {:.2e}'.format(mean_CHF3))
print('La valeur de la moyenne des données PAN est :  {:.2e}'.format(mean_PAN))

print('La valeur de STD des données CHF3 (dofs = 1) est:  {:.2e}'.format(std_CHF3))
print('La valeur de STD des données PAN (dofs = 1) est :  {:.2e} '.format(std_PAN))

print('La valeur de la médiane des données CHF3 est :  {:.2e}'.format(median_CHF3))
print('La valeu de la médiane des données PAN  est :  {:.2e} '.format(median_ACE_IRA))


print('La valeur de la random error  des données CHF3 est : {:.2e}'.format(random_error_CHF3))
print('La valeur de la random error  des données PAN est : {:.2e}'.format(random_error_PAN))


# # Autre stat d'après le code Issep (Coraline)

# In[83]:

X2 = df_merged_2['CHF3'] #calculated value 
Y2 = df_merged_2['retrieved_total_column__CHF3'] #predicted value 


# Visualisation des données de 2012 en une couleur et de la période 2016-2019 d'une autre pour voir si ces données 
# s'écartent de mon nuage de points principal et si ce ne n'est pas des outliers 

# ### Pour les data de 2012  et entre 2016-2019 

# In[85]:

data_2012 = df_merged_2.loc[(df_merged_2['YearFraction_x'] >= 2012.0) & (df_merged_2['YearFraction_x'] < 2013.0)]
X2012 = data_2012['CHF3']
Y2012 = data_2012['retrieved_total_column__CHF3']

data_2016_2019 = df_merged_2.loc[(df_merged_2['YearFraction_x'] >= 2016.0) & (df_merged_2['YearFraction_x'] < 2019.0)]
X20162019 = data_2016_2019['CHF3']
Y20162019 = data_2016_2019['retrieved_total_column__CHF3']


# In[88]:

## visualisation de tous les jeux de données 
axes = plt.axes()
axes.grid()
plt.axis([2e14, 6e14, 2e14, 6e14]) #pour mettre la même échelle de valeur selon x et y 
plt.scatter(X2,Y2, marker='+', s=15, label='all data')
plt.scatter(X2012,Y2012, marker='+', color='red', s=15, label='data 2012')
plt.scatter(X20162019,Y20162019, marker='+', color='green', s=15, label='data 2016-2019')
plt.title('Observed VS predicted Values of CHF3')
plt.xlabel('Observed Values (PAN)')
plt.ylabel('Predicted Values (CHF3)')
plt.legend(loc='best')
plt.savefig(output_plot + 'Observed_vs_predicted_PAN_CHF3_modif.png', dpi=300)
plt.show() 


# In[99]:

##visualisation du jeu de donnée 
axes = plt.axes()
axes.grid()
plt.axis([2e14, 6e14, 2e14, 6e14]) #pour mettre la même échelle de valeur selon x et y 
plt.scatter(X2,Y2, marker='+', s=15, label='all data')
plt.title('Observed VS predicted Values of CHF3')
plt.xlabel('Observed Values (PAN)')
plt.ylabel('Predicted Values (CHF3)')
plt.legend(loc='best')
plt.show() 


# In[96]:

## entrainement modèle regression linéaire 
slope, intercept, r_value, p_value, std_err = stats.linregress(X2, Y2)


# In[97]:

slope, intercept, r_value, p_value, std_err
#afficher différents paramètres stat 


# In[98]:

## écriture de la fonction de prédiction 
def predict(x):
    return slope * x + intercept


# In[100]:

output_plot = 'C:\\Users\\ACER\\Documents\\Cours_et_al\\Stat_data_Stage_TFE\\stat\\out_plot_stat\\'

# Affichage de a et de b (fonction round pour arrondir)
a = round(slope, 4)
b = round(intercept, 4)


# Affichage de la fonction de prédiction 
axes = plt.axes()
axes.grid()
plt.axis([2e14, 6e14, 2e14, 6e14]) #pour mettre la même échelle de valeur selon x et y 
plt.scatter(X2, Y2, marker='+', s=15, label='data')
plt.title('Observed VS predicted Values of CHF3')
plt.xlabel('Observed Values (PAN)')
plt.ylabel('Predicted Values (CHF3)')
regression_coef = a
regression_intercept = b
fitLine = predict(X2)
plt.plot(X2, fitLine, c='r', label=f'equation: {regression_coef}x + {regression_intercept: .2e}')
plt.legend(loc='best')
plt.savefig(output_plot + 'Observed_vs_predicted_PAN_CHF3.png', dpi=300)
plt.show()



print("La valeur de a est:", a)
print("La valeur de b est: {:.2e}".format(b))


# In[104]:

# Affichage de a et de b (fonction round pour arrondir)
a = round(slope, 4)
b = round(intercept, 4)


# Affichage de la fonction de prédiction 
axes = plt.axes()
axes.grid()
plt.axis([2e14, 6e14, 2e14, 6e14]) #pour mettre la même échelle de valeur selon x et y 
plt.scatter(X2, Y2, marker='+', s=15, label='all data')
plt.scatter(X2012,Y2012, marker='+', color='orange', s=15, label='data 2012')
plt.scatter(X20162019,Y20162019, marker='+', color='green', s=15, label='data 2016-2019')
plt.title('Observed VS predicted Values of CHF3')
plt.xlabel('Observed Values (PAN)')
plt.ylabel('Predicted Values (CHF3)')
regression_coef = a
regression_intercept = b
fitLine = predict(X2)
plt.plot(X2, fitLine, c='r', label=f'equation: {regression_coef}x + {regression_intercept: .2e}')
plt.legend(loc='best')
plt.savefig(output_plot + 'Observed_vs_predicted_PAN_CHF3_modified_with_trend.png', dpi=300)
plt.show()



print("La valeur de a est:", a)
print("La valeur de b est: {:.2e}".format(b))


# In[101]:

#Compute statistics
    #CORRELATION
column_1 = Y2 #predicted value
column_2 = X2 #calculate value
corr = column_1.corr(column_2)

#corr

 #ROOT MEAN SQUARE ERREOR
RMSE =((Y2 - X2) ** 2).mean() ** .5
#RMSE

#MEAN BIASES
Mean_biais =((Y2- X2)).mean()
#Mean_biais


stat_resume = 'R\u00B2='+str(round(corr, 2)) + ', Mean biais={:.2e}'.format(Mean_biais) + ', RMSE={:.2e}'.format(RMSE)

print(stat_resume)
#\u00B2 -> à mettre après le 'R' pour avoir l'exposant au carré



# In[ ]:



